<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" :label-width="80" v-show="searchOpen" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托编号:">
                <Input @on-enter="_formSearch" v-model="formObj.entrustCode" name="entrustCode" placeholder="请输入样品编号" clearable/>
              </Form-item>
              <Form-item class="search-item" label="试样编号:">
                <Input @on-enter="_formSearch" v-model="formObj.sampleCode" name="sampleCode" placeholder="请输入样品名称" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" :showSearchBtn="true"
                     class="contHide">
            </btn-list>
          </Col>
          <!--样品数量-->
          <!-- 表格 -->
          <Col span="24">
            <PTVXETableHeight ref="pageTable" :table-height="tableHeight" :loading="true"
                        :get-page="getPage" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.key==='quantity'" @click.stop="_handleIndex(scope)">
                    <div v-if="editIndex!==scope.rowIndex">
                      {{scope.row[item.key]}}
                    </div>
                    <div v-else>
                      <Input :value="scope.row.quantity" @change.native="inputChange($event.target.value)" clearable placeholder="请输入备样数量"></Input>
                    </div>
                  </div>
                  <div v-else-if="item.key==='conditions'" @click.stop="_handleIndex(scope)">
                    <div v-if="editIndex!==scope.rowIndex">{{scope.row[item.key]}}</div>
                    <div v-else>
                      <el-select :value="scope.row.conditions" @change="selCondi" style="width:100%" size="small">
                        <el-option v-for="item in conditionList" :value="item.name" :key="item.name">{{ item.name }}
                        </el-option>
                      </el-select>
                    </div>
                  </div>
                  <div v-else-if="item.key==='backupUser'" @click.stop="_handleIndex(scope)">
                    <div v-if="editIndex!==scope.rowIndex">{{scope.row[item.key]}}</div>
                    <div v-else>
                      <el-select :value="scope.row.backupUser" @change="selUser" style="width:100%" size="small">
                        <el-option v-for="item in backupUserList" :value="item.id" :label="item.realname" :key="item.realname">{{ item.realname }}
                        </el-option>
                      </el-select>
                    </div>
                  </div>
                  <div v-else-if="item.key==='backupLocation'" @click.stop="_handleIndex(scope)">
                    <div v-if="editIndex!==scope.rowIndex">
                      {{scope.row[item.key]}}
                    </div>
                    <div v-else>
                      <Input :value="scope.row.backupLocation" @change.native="locaChange($event.target.value)" clearable placeholder="请输入备样位置"></Input>
                    </div>
                  </div>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
              <vxe-table-column
                slot="col"
                :width="80"
                title="操作"
                align="center"
                fixed="right">
                <template slot-scope="scope">
                  <VXEIconList :msg="editIndex===scope.rowIndex?iconMsgSave:iconMsg" @on-result-change="_iconClick" :rowData="scope.row" :rowIndex="scope.rowIndex"></VXEIconList>
                </template>
              </vxe-table-column>
            </PTVXETableHeight>
          </Col>
        </Row>
      </div>
    </div>
    <SampleParpareApply ref="applyModal" @on-result-change="_page"></SampleParpareApply>
    <Operation ref="recordModal"></Operation>
    <SampleParpareBatchEdit ref="batchEdit" @on-result-change="_page"></SampleParpareBatchEdit>
  </div>
</template>
<script>
// import AutoCompletes from '../../../../components/base/AutoCompletes'
import SampleParpareApply from '../SampleParpareApply'
import SampleParpareBatchEdit from '../SampleParpareBatchEdit'
// eslint-disable-next-line no-unused-vars
import http from '../../../../api/http'
import { soilEntrust, soilSample } from '../../../../api'
import Operation from '../../../../components/operation/Operation'
export default {
  components: {
    // AutoCompletes,
    SampleParpareApply,
    SampleParpareBatchEdit,
    Operation
  },
  data() {
    return {
      currentComponent: '',
      searchOpen: false,
      formObj: {},
      selectData: [],
      selectIds: [],
      selectSampleIds: [],
      getPage: {},
      btn: [
        {
          type: 'primary',
          id: '',
          name: '申请处理'
        },
        {
          type: 'primary',
          id: '',
          name: '完成处理'
        },
        {
          type: 'primary',
          id: '',
          name: '批量填写存放信息'
        }
        // { type: '', id: '', name: '填写存放信息' },
        // { type: '', id: '', name: '申请处理' },
        // { type: '', id: '', name: '导出' },
      ],
      iconMsg: [
        { type: 'md-create', id: '', name: '编辑' }, // food-sample-prepare-edit
        { type: 'ios-clock', id: '', name: '操作日志' } // food-sample-prepare-edit
      ],
      iconMsgSave: [
        { type: 'ios-checkmark', id: '', name: '保存' },
        { type: 'ios-clock', id: '', name: '操作日志' }
      ],
      pageColumns: [
        { title: '委托商', key: 'client', width: 180 },
        { title: '委托编号', key: 'entrustCode', width: 100 },
        { title: '试样编号', key: 'sampleCode', width: 100 },
        { title: '状态', key: 'status', width: 100, status: true },
        { title: '试样深度', key: 'sampleDepth', width: 100 },
        { title: '样品包装类型', key: 'samplePack', width: 120 },
        { title: '现场编号', key: 'siteNo', width: 100 },
        { title: '钻孔位置', key: 'boreholeLocation', width: 110 },
        { title: '钻孔名称', key: 'boreholeName', width: 160 },
        { title: '水深（米）', key: 'waterDepth', width: 100 },
        { title: '存储条件', key: 'conditions', width: 180 },
        { title: '备样位置', key: 'backupLocation', width: 180 },
        { title: '备样数量', key: 'quantity', width: 180 },
        { title: '备样人', key: 'backupUser', width: 140 }
        // { title: '备份开始日期', key: 'startTime', width: 170 },
        // { title: '备份结束日期', key: 'endTime', width: 170 }
        /*  {title: '处置方式', key: 'handleMethod', width: 120,}, */
      ],
      conditionList: [],
      backupUserList: [],
      locList: [],
      currentIndex: -1,
      editIndex: -1,
      endDateBegin: '',
      endDateEnd: '',
      contList: [
        { key: 'backupCount', name: '今日新增数量', value: 0 },
        {
          key: 'backupCountOver',
          name: '超期数量',
          value: 0,
          color: 'red-color'
        },
        {
          key: 'backupCountWarn',
          name: '预警数量',
          value: 0,
          color: 'warning-color'
        }
      ],
      // 只看预警和超期样品
      warnAndOver: 0,
      sampleHandleValue: '',
      issueDateBegin: '',
      issueDateEnd: '',
      isEligible: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('', 255)
      } else {
        return this.$tableHeight('', 220)
      }
    },
    colorComputed() {
      return function(date) {
        if (this.$warningValue(date) < 0) {
          return '#eb6877' // 红色
        } else if (
          this.$warningValue(date) >= 0 &&
          this.$warningValue(date) <= this.sampleHandleValue
        ) {
          return '#f90' // 橙色
        }
      }
    }
  },
  mounted() {
    this.$refs.pageTable._showLoading()
    this._getConditionList()
    this._getUserList()
  },
  methods: {
    // 签发日期
    _issueDateChange(date) {
      this.issueDateBegin = date[0]
      this.issueDateEnd = date[1]
    },
    // 重新请求page以及备样数量
    _relPage() {
      this._page()
      // this._getBackUpCount()
    },
    // 选择时间
    _endDateChange(data) {
      this.getPage.records[this.currentIndex].endDate = data
    },
    // 查询-接收日期
    _dateChange(data) {
      this.endDateBegin = data[0]
      this.endDateEnd = data[1]
    },
    _save() {
      this.$nextTick(function() {
        const tempData = {
          quantity: this.getPage.records[this.currentIndex].quantity,
          conditions: this.getPage.records[this.currentIndex].conditions,
          backupLocation: this.getPage.records[this.currentIndex]
            .backupLocation,
          backupUser: this.getPage.records[this.currentIndex].backupUser,
          backupUserId: this.getPage.records[this.currentIndex].backupUserId
        }
        this._saveOk({
          id: this.getPage.records[this.currentIndex].id,
          obj: tempData
        })
      })
    },
    _saveOk: async function(data) {
      const result = await soilSample.editBackup(data)
      if (result) {
        this.$Message.success('编辑成功')
      }
    },
    _iconClick(res, data, componentName, index) {
      this.currentIndex = index
      switch (res) {
        case '编辑':
          this.editIndex = index
          break
        case '操作日志':
          this._record(data.id)
          break
        case '保存':
          // if (data.endDate !== '') {
          //   // 非空情况下格式化赋值，如果不判断会格式化为当天的日期
          //   this._endDateChange(this.$dateformat(data.endDate, 'yyyy-mm-dd'))
          // }
          this._save()
          this.editIndex = -1
          break
      }
    },
    _getUserList: async function() {
      const result = await soilSample.getUserList()
      if (result) {
        console.log(result)
        this.backupUserList = result.records
      }
    },
    selCondi(data) {
      this.$forceUpdate()
      this.getPage.records[this.currentIndex].conditions = data
    },
    selUser(data) {
      this.$forceUpdate()
      if (data) {
        for (let i = 0; i < this.backupUserList.length; i++) {
          if (this.backupUserList[i].id === data) {
            this.getPage.records[
              this.currentIndex
            ].backupUser = this.backupUserList[i].realname
          }
        }
      } else {
        this.getPage.records[this.currentIndex].backupUser = ''
      }
      this.getPage.records[this.currentIndex].backupUserId = data
      console.log(this.getPage.records[this.currentIndex])
      // this.$forceUpdate()
      // this.getPage.records[this.currentIndex].backupUser = data
      // this.getPage.records[this.currentIndex].backupUser = data
    },
    inputChange(data) {
      this.getPage.records[this.currentIndex].quantity = data
    },
    locaChange(data) {
      this.getPage.records[this.currentIndex].backupLocation = data
    },
    _record(id) {
      this.$refs.recordModal._openBcakup(id)
    },
    _getConditionList: async function() {
      const result = await soilSample.getDictList('存储条件')
      if (result) {
        this.conditionList = result
      }
    },
    // 操作的序号
    _handleIndex(data) {
      this.currentIndex = data.rowIndex
    },
    _btnClick(msg) {
      switch (msg) {
        case '申请处理':
          this._applyDispose()
          break
        case '批量填写存放信息':
          this._writeInfo()
          break
        case '完成处理':
          this._handleApply()
          break
        case '制备':
          this._preMethod()
          break
        case '无需制备':
          this._noPreMethod()
          break
        case '扫码制备':
          this._scanPreMethod()
          break
        case '填写存放信息':
          this._batchEdit()
          break
        case '导出':
          if (this.getPage.records.length === 0) {
            this.$Message.warning('暂无数据，不可导出')
          } else {
            this._export()
          }
          break
        case '导出备样记录':
          this._exportReceiveRecord()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _writeInfo() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.batchEdit._open(this.selectIds)
      }
    },
    _handleApply() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        console.log(this.selectData)
        const errorIds = []
        for (let i = 0; i < this.selectIds.length; i++) {
          if (this.selectData[i].status.display !== '处理审批通过') {
            errorIds.push(this.selectData[i].index + 1)
          }
        }
        if (errorIds.length === 0) {
          this.$Modal.confirm({
            title: '提示',
            content: '确定处理这 ' + this.selectIds.length + ' 条数据？',
            onOk: () => {
              this._handleOk(this.selectIds.join(','))
            }
          })
        } else {
          // this.$Notice.error({
          //   title: '文件格式不正确',
          //   duration: 10,
          //   desc: '试样编号为 ' + errorIds + ' 的审批未通过'
          // })
          // this.$Message.warning('试样编号为 ' + errorIds + ' 的审批未通过')
          this.$notify({
            title: '提示',
            message: '第 ' + errorIds + ' 行数据的审批未通过',
            duration: 4000,
            type: 'error'
          })
          // this.$Modal.confirm({
          //   title: '提示',
          //   content: '试样编号为 ' + errorIds + ' 的审批未通过'
          // })
        }
      }
    },
    _handleOk: async function() {
      const result = await soilSample.handleOk({
        ids: this.selectIds.join(',')
      })
      if (result) {
        this._resultChange('提交成功')
      }
    },
    _resultChange(msg) {
      this.$Message.success(msg)
      this._page()
    },
    _applyDispose() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.applyModal._open(this.selectIds)
      }
    },
    // 制备
    _preMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.preModal._open(this.selectSampleIds)
      }
    },
    // 无需制备
    _noPreMethod() {
      if (this.selectSampleIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.noPreModal._open(this.selectSampleIds)
      }
    },
    _scanPreMethod() {
      this.$refs.scanPreModal._open()
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          this.selectSampleIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
            this.selectSampleIds.push(data[i].sampleId)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
      // this._getBackUpCount()
    },
    _page: async function() {
      this.editIndex = -1
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilEntrust.pageBackup(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _batchEdit() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.editModal._open(this.selectData)
      }
    },
    _handle() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.applyModal._open(this.selectData)
      }
    },
    // 参数
    _searchParams() {
      const data = this.$serialize('search-form')
      return this.$extend(data, { page: 1, rows: 5000 })
    }
    /** *********************************导出样品台账-end*********************************************/
  }
}
</script>
<style>
.el-notification__content p {
  white-space: pre-wrap !important;
  word-wrap: break-word;
  word-break: break-all;
}
/******副样、备样卡片********/
.reimbursement-item {
  flex: 1;
  border-radius: 5px;
  border: 1px solid #e8e8e8;
  padding-bottom: 10px;
}

.reimbursement-item + .reimbursement-item {
  margin-left: 20px;
}

.reimbursement-item p {
  text-align: center;
  margin: 0;
}

.reimbursement-item > p:first-child {
  font-size: 22px;
  line-height: 40px;
}
</style>
